library ieee;
use ieee.std_logic_1164.all;

entity mcm_sc is
  port(clk, nw: in std_logic;
       A,B : in integer;
       R: out integer;
       fine: out std_logic);
end mcm_sc;

architecture schematic of mcm_sc is
  
 component cu is
  port (nw, clk: in std_logic;
	   ma, mb:  in integer;
        sela,selb,rega,regb,regm,fine: out std_logic);
end component;
 
 component adder is
  port(A,B: in integer;
       R: out integer
     );
 end component;

 component registroi is
  port (clk: in std_logic;
        mi: in integer;
        mo: out integer);
end component;

component muxi is
  port (a,b: in integer;
        sel: in std_logic;
        q: out integer);
 end component;
 

signal sela,selb,rega,regb,regm: std_logic;
signal sa,mma,sb,mmb,ma,mb: integer;
signal clka,clkb,clkm: std_logic;

begin
  
  cus: cu port map (nw, clk, ma, mb,sela,selb,rega,regb,regm,fine);

  adda: adder port map(a,ma,sa);
  addb: adder port map(b,mb,sb);
  muxa: muxi port map(a,sa,sela,mma);
  muxb: muxi port map(b,sb,selb,mmb);

  clka <= clk and rega;
  clkb <= clk and regb;
  clkm <= clk and regm;
  
  rga:  registroi port map (clka,mma,ma);
  rgb: registroi port map (clkb,mmb,mb);
  rgm: registroi port map (clkm,ma,R);
end schematic; 

